/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////
var scbObjs = [];
/* 添加生词本
 * 参数格式json:
 * jsonData = {
 *     "wid":"",                                 //wid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 *     "failedCallback":"onScbFailed"            //失败回调函数
 * }
 */
function addScb(jsonData, obj){
    jsonData = parseJson(jsonData);
    scbObjs[jsonData.uwid] = obj;
    try{ dictcn.addScb(JSON.stringify({'uwid':jsonData.uwid,'successCallback':'onScbSuccess','failedCallback':'onScbFailed'})); }catch(e){}
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "wid":"",                                 //wid
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    try{
        var $wordhead = $('.wordhead');
        if($wordhead.length>1){
            $wordhead.children('.scbadd').children('img').attr('src',_resource_+'/images/btn-added.png');
        } else {
            scbObjs[jsonData.uwid].src = _resource_+'/images/btn-added.png';
        }
    }catch(e){}
}
///////////////////////////播放声音/////////////////////////////////////////////////////////////////////
var globAnima = null, globCurObj = null,defSoundSrc = '';
/* 本地播放声音
 * 参数格式json:
 * jsonData = {
 *     "lang":"b",                                 //语种
 *     "key":"tuaminoheptane",                    //word
 *     "scode":"QG",                              //scode
 *     "url":"url"                                //mp3地址，支持url发音
 *     "startCallback":"onStartPlaySound",         //开始播放动画js回调
 *     "endCallback":"onEndPlaySound"              //停止播放动画js回调
 * }
 */
function playSound(jsonData,obj){
    jsonData = parseJson(jsonData);
    onEndPlaySound();
    globCurObj = $(obj);
    defSoundSrc = $(obj).attr('src');
    var symbol = jsonData.symbol ? jsonData.symbol : "";
    var pinyin = jsonData.pinyin ? jsonData.pinyin : "";
    var v = jsonData.v ? jsonData.v : "";
    var uwid = jsonData.uwid ? jsonData.uwid : "";
    try{ dictcn.playSound(JSON.stringify({'uwid':jsonData.uwid,'lang':jsonData.lang,'key':jsonData.key,'scode':jsonData.scode,'symbol':symbol,'pinyin':pinyin,'v':v,'startCallback':'onStartPlaySound','endCallback':'onEndPlaySound'})); }catch(e){}
}
         
/* 开始播放动画
 * 参数格式json:
 * jsonData = {
 *     "key":"soundKey"                            //发音单词
 * }
 */
function onStartPlaySound(jsonData){
    jsonData = parseJson(jsonData);
    try{
        var i = 1;
        globAnima = setInterval(function(){
            if(i>3) i=1;
            globCurObj.attr('src',_resource_+'/images/btn-voice-'+i+'.png');
            i++;
        },200);
    }catch(e){}
}

/* 停止播放动画
 * 参数格式json:
 * jsonData = {
 *     "key":"soundKey"                            //发音单词
 * }
 */
function onEndPlaySound(jsonData){
    jsonData = parseJson(jsonData);
    try{
        clearInterval(globAnima);
        globCurObj.attr('src', defSoundSrc);
    }catch(e){}
}
////////////////////////////查字或词组////////////////////////////////////////////////////////////////////////////
/* 查字
 * 参数格式json:
 * jsonData = {
 *     text:"",                                 //要查询的字
 * }
 */
function searchText(jsonData){
    jsonData = parseJson(jsonData);
    try{ dictcn.searchText(JSON.stringify({'text':jsonData.text})); }catch(e){}
}

/* 查词组
 * 参数格式json:
 * jsonData = {
 *     text:"",                                 //要查询的词组
 *     successCallback:"onPhraseSuccess",
 *     failedCallback:"onPhraseFailed"
 * }
 */
var globPhraseObj = null;
function ajaxSearch(jsonData,obj,display){
    jsonData = parseJson(jsonData);
    if(typeof(display)=="undefined") display = "block";
    if($(obj).next()[0].style.display==display){
        $(obj).children('.arrowbtn').children('img').attr('src',_resource_+'/images/arrow-up.png');
        if($(obj).next().children('.ajax-search').length){ $(obj).next().show(); return; }
        try{
            $(obj).next().html('<div class="phrase-loadding">Loading...</div>');
            //if(globPhraseObj && globPhraseObj!=obj) $(globPhraseObj).next().html('<div class="phrase-loadding">Failed to load. Please try again later!</div>');
            $(obj).next().show();
            globPhraseObj = obj;
            dictcn.ajaxSearch(JSON.stringify({'text':jsonData.text,'tplName':jsonData.tplName,'from':jsonData.from,'successCallback':'onAjaxSuccess','failedCallback':'onAjaxFailed'}));
        }catch(e){}
    } else {
        $(obj).next().hide();
        $(obj).children('.arrowbtn').children('img').attr('src',_resource_+'/images/arrow-down.png');
    }
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     wid:"",                                 //wid
 *     html:""                                 //返回的html片段
 * }
 */
function onAjaxSuccess(jsonData){
    jsonData = parseJson(jsonData);
    try{
        var $uwidEle = $('#uwid'+jsonData.uwid);
        $uwidEle.next().html(jsonData.html);
        globPhraseObj = null;
        if(auto_uwid) {
            scrollToView($uwidEle[0]);
            auto_uwid='';
            if($uwidEle.next()[0].style.display=="none") $uwidEle.next().show();
         }
    }catch(e){}
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     wid:"",                                 //wid
 *     tip:""                                  //提示信息
 * }
 */
function onAjaxFailed(jsonData){
    jsonData = parseJson(jsonData);
    try{
        document.getElementById('uwid'+jsonData.uwid).innerHTML = jsonData.tip ? jsonData.tip : '加载失败!';
    }catch(e){}
}

///////////////////播放笔顺动画///////////////////////////////////////////////////////////////////////////////////////
function popupPlayStroke(jsonData){
     jsonData = parseJson(jsonData);
     var tplname = "stroke.chtml";
     if(typeof(jsonData.tplName)!="undefined") tplname = jsonData.tplName;
     try{ dictcn.popupPlayStroke(JSON.stringify({'word':jsonData.word, 'pinyins':jsonData.pinyins,'cvec':jsonData.cvec,'sorder':jsonData.sorder})); }catch(e){}

}


//////////////////////////// 图片异步加载 //////////////////////////////////
function nativeLoadImage(jsonData, obj){
    jsonData = parseJson(jsonData);
    var img_id = "image_id_"+new Date().getTime()+""+Math.floor(Math.random()*10000);
    $(obj).attr("id", img_id);
    try{ dictcn.nativeLoadImage(JSON.stringify({'url':jsonData.url,'image_id':img_id})); }catch(e){}
}


function onImageLoadSuccess(jsonData){
    jsonData = parseJson(jsonData);
    try{ $("#"+jsonData.image_id).attr("src", jsonData.path); }catch(e){}
      
}
function onImageLoadFailed(jsonData){
    jsonData = parseJson(jsonData);
    try{ $("#"+jsonData.image_id).attr("src", _resource_+'/images/default.png'); }catch(e){}
}

//////////////////////////// usefull functions //////////////////////////////////
// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}